#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;



struct Input {
    vector<double> numbers;
    size_t bin_count{};
    double USER_BIN_HEIGHT{};
};

Input input_data(istream& stream, bool prompt) {


    size_t number_count;
    if (prompt) {
        cerr << "Enter number count: ";
    }
    stream >> number_count;

    Input in;

    in.numbers.resize(number_count);

    if (prompt){
            cerr << "Enter numbers: ";
    }
    for (size_t i = 0; i < number_count; i++)
    {
        stream >> in.numbers[i];
    }

    if (prompt){
    cerr << "Enter number of bins: ";
    }
        stream >> in.bin_count;

    if (prompt){
        cerr << "Enter image height: ";
    }
    stream >> in.USER_BIN_HEIGHT;

    return in;
}




int main(int argc, char* argv[]){

    if (argc > 1){

        CURL* curl = curl_easy_init();

        if(curl) {

            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);

            curl_easy_cleanup(curl);
        }

        return 0;
    }

    curl_global_init(CURL_GLOBAL_ALL);

    bool prompt= true;

    Input in = input_data(cin, prompt);

    auto bins = make_histogram(in.numbers, in.bin_count);

    show_histogram_svg(bins, in.USER_BIN_HEIGHT);


    }
